var HTML5DemoDonutGaugeElementWrapper;

/* This HTML5 element demonstrates how an HTML5 
	* element can be used with the help of the d3 library.
	* The changeable size of the frame area is passed directly by widht and height.
	*/

(function () {
  HTML5DemoDonutGaugeElementWrapper = function (width, height) {
	this.width = width;
	this.height = height;
    this.d = new DonutGauge(
            "body",
            this.width,
            this.height
          );
    this.addEventListener();
  };
  HTML5DemoDonutGaugeElementWrapper.prototype = {
    addEventListener: function () {
      var self = this;
	  window.addEventListener("UpdateTargetValue", function(evt)
	  {
		if (evt.detail != null)
		{
			if (window.CDSWebVisuAccess.checkSimpleValue('SetTargetValue', parseInt(evt.detail)))
				self.SendTargetValue(parseInt(evt.detail));
		}
	  });
    },
    SetValue: function (value, type, typeid) {
		console.log("SetValue:" + value +"--")
      if (typeof this.d != "undefined") this.d.SetValue(value);
      else console.log("cannot setValue this.d is not defined");
    },
    SetMaximum: function (value, type, typeid) {
		console.log("SetMaximum:" + value +"--")
	  if (typeof this.d != "undefined")
	  this.d.SetMaximum(value);
    },
    SetMinimum: function (value, type, typeid) {
		console.log("SetMinimum:" + value +"--")
	  if (typeof this.d != "undefined")
	  this.d.SetMinimum(value);
    },
    SetForegroundColor: function(value, type, typeid){
		console.log("SetForegroundColor:" + value +"--")
    if (typeof this.d != "undefined")
    this.d.SetForegroundColor(value);  
    },
    SetBackgroundColor: function(value, type, typeid){
	  console.log("SetBackgroundColor:" + value +"--")
      if (typeof this.d != "undefined")
      this.d.SetBackgroundColor(value);
    },
    SetDeviderColor:function(value, type, typeid){
	console.log("SetDeviderColor:" + value +"--")
    if (typeof this.d != "undefined")
    this.d.SetDeviderColor(value);
    },
    SetLabelTopText:function(value, type, typeid){
	  console.log("SetLabelTopText:" + value +"--")
      if (typeof this.d != "undefined")
      this.d.SetLabelTopText(value);
    },
    SetLabelBottomText:function(value, type,typeid){
	  console.log("SetLabelBottomText:" + value +"--")
      if (typeof this.d != "undefined")
      this.d.SetLabelBottomText(value);
    },
    SetLabelTopFont:function(value, type, typeid){
	  console.log("SetLabelTopFont:" + value +"--")
      if (typeof this.d != "undefined")
      this.d.SetLabelTopFont(value);
    },
    SetLabelBottomFont:function(value, type, typeid){
	  console.log("SetLabelFont:" + value +"--")
      if(typeof this.d != "undefined")
      this.d.SetLabelBottomFont(value);
    },
    SetValueFont:function(value, type, typeid){
	  console.log("SetValueFont:" + value +"--")
      if(typeof this.d != "undefined")
      this.d.SetValueFont(value);
    },
    SetSliderColor:function(value, type, typeid){
	console.log("SetSliderColor:" + value +"--")
    if (typeof this.d != "undefined")
    this.d.SetSliderColor(value);
    },
	SetSliderColor:function(value, type, typeid){
	console.log("SetSliderColor:" + value +"--")
    if (typeof this.d != "undefined")
    this.d.SetSliderColor(value);
    },
	SetTargetValue:function(value, type, typeid){
	console.log("SetTargetValue:" + value +"--")
    if (typeof this.d != "undefined")
    this.d.SetTargetValue(value);
    },
	SendTargetValue:function(value)
	{
		window.CDSWebVisuAccess.sendSimpleValue('SetTargetValue',value);
	}
  };
})();
